
Option Explicit

'TODO: parent proc - scheduled task or not

Dim AFUNCTIONS : AFUNCTIONS = "A_FUNCTIONS.vbs" 'set include name
Include ScriptPath & AFUNCTIONS
Include ScriptPath & "cURLFTP_class.vbs"

Dim sParentProcName, aFiles, aFiles_mod, Apertura_mod, A_FUNCTIONS_mod, cURLFTP_class_mod
Dim ftp, sIP, sInput, sOutput, sError, sReg, aReg, aDir, bChanged, i, str, sCmd, sTmp, sRet, aProc

On Error Resume Next
'Avslutt forrige Apertura.vbs dersom skriptet allerede kjrer
If ProcCmdLineCount("wscript.exe", "\" & WScript.ScriptName) > 1 Then
	KillProc InProcCmdLine("wscript.exe", "\" & WScript.ScriptName)(0)
End If
DeleteFile ScriptPath & "Apertura_Error.log"

'Opprett planlagt oppgave dersom skriptet kjrer som 64-bit og ikke som planlagt oppgave
sParentProcName = procName(ParentProcID(InProcCmdLine("wscript.exe", WScript.ScriptFullName)(0)))
If sParentProcName <> "svchost.exe" And InStr(LCase(WScript.Path), "\system32") Then
	CreateTaskAperturaScript
	WScript.Quit
End If

aFiles = Array("Apertura.vbs", AFUNCTIONS, "cURLFTP_class.vbs")
aFiles_mod = Array("Apertura_mod", "A_FUNCTIONS_mod", "cURLFTP_class_mod")

Apertura_mod = FileModified(ScriptPath & "Apertura.vbs")
A_FUNCTIONS_mod = FileModified(ScriptPath & AFUNCTIONS)
cURLFTP_class_mod = FileModified(ScriptPath & "cURLFTP_class.vbs")

Set ftp = New cURLFTP
If FileExists(ScriptPath & "curl.exe") Then
	ftp.Path = ScriptPath
Else
	ftp.Path = sInstallPath
End If
If DomainName <> "APERTURA" And ComputerName <> "AUTO-PC" Then
	ftp.proxy = " -x slb.flex-proxy.nhn.no:8080"
	sIP = NHNIP
	If sIP = "" Then sIP = IP
Else
	sIP = IPByGateway("", "10.10.34.1")
End If
sInput = sIP & "_Input.txt"
sOutput = sIP & "_Output.txt"
sError = "ERROR: The requested URL could not be retrieved"
'registrer maskin dersom den ikke er registrert
sReg = sIP & " " & MachineGuid
aReg = Split(ftp.Directory("reg/"), vbNewLine)
If UBound(Filter(aReg, sReg)) < 0 Then

End If
Do
	If Err.Number > 0 Then
		AppendTextToFile Now & vbTab & Err.Number & vbTab & Err.Description & vbNewLine, ScriptPath & "Apertura_Error.log"
		Err.Clear
	End If
	aDir = Split(ftp.Directory(""), vbNewLine)
	If UBound(Filter(aDir, ".vbs")) > -1 Then
		bChanged = False
		For i = 0 To UBound(aFiles)
			If UBound(Filter(aDir, aFiles(i))) > -1 Then
				str = Filter(aDir, aFiles(i))(0)
				If CDate(Mid(str, 43, 12)) > Eval(aFiles_mod(i)) Then
					str = ftp.File(aFiles(i))
					If str <> "" And InStr(str, "<!-- ERR_FTP_NOT_FOUND -->") = 0 Then
						TextToFile str, ScriptPath & aFiles(i)
						bChanged = True
					End If
				End If
			End If
		Next
		If bChanged Then
			RunScript32 WScript.ScriptFullName, False
			WScript.Quit
		End If
	End If
	If UBound(Filter(aDir, sInput)) > -1 Then
		sCmd = ftp.File(sInput)
		If sCmd <> "" Then 
			If InStr(sCmd, sError) = 0 Then
				AppendTextToFile Now & ": {" & sCmd & "}" & vbNewLine, ScriptPath & "Apertura.log"
				If InStr(sCmd, vbNewLine) Then
					Execute sCmd	'evt. resultat til sRet
				Else
					sRet = Eval(sCmd)
				End If
				sTmp = TmpFile("")
				TextToFile "[" & sIP & "]" & vbNewLine & sRet, sTmp
				ftp.Upload sOutput, sTmp
				DeleteFile sTmp
				sTmp = ""
			Else
				ftp.Upload sOutput, ""
			End If
		End If
		sCmd = ""
		ftp.DeleteFile sInput
	End If
	If FileModified(ScriptPath & AFUNCTIONS) <> A_FUNCTIONS_mod Then
		 RunScript32 WScript.ScriptFullName, False
	End If
	WScript.Sleep 5000
	If ProcCmdLineCount("wscript.exe", "\" & WScript.ScriptName) > 1 Then
		Exit Do
	End If
Loop
Set ftp = Nothing

Function ScriptPath
	ScriptPath = Left(WScript.ScriptFullName, InStrRev(WScript.ScriptFullName, "\"))
End Function

Sub Include(sFile)
	Dim s
	If sFile = WScript.ScriptFullName Then Exit Sub
	With CreateObject("Scripting.FileSystemObject")
		s = .GetBaseName(sFile) & "_Loaded"
		If Not Eval(s) Then
			ExecuteGlobal "Dim " & s & ":" & s & " = True"
			With .OpenTextFile(sFile)
				ExecuteGlobal .ReadAll
				.Close
			End With
		End If
	End With
End Sub


